<route lang="yaml">
meta:
  enabled: false
</route>

<script lang="ts" setup name="Oc">
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { createOcAdmin, getOcAdmin, updateOcAdmin } from '@/api/system/ocApi'
const emit = defineEmits(['success'])

const formRef = ref<FormInstance>()
const formRules = ref<FormRules>({
  ocName: [
    { required: true, message: '请输入标题', trigger: 'blur' },
  ],
  ocTypeId: [
    { required: true, message: '请输入类型', trigger: 'blur' },
  ],
  ocCatId: [
    { required: true, message: '请输入分类', trigger: 'blur' },
  ],
})

const state = reactive({
  title: '',
  dialogVisible: false,
  loading: false,
  formData: {
    ocId: undefined, // 企业Id
    adminId: undefined,
    adminName: '', // 账号
    adminPhone: '', // 手机号
  },
  actionType: 1,
})

onMounted(() => {})

const getData = async (ocId: number) => {
  state.loading = true
  const { data } = await getOcAdmin(ocId)
  state.loading = false
  state.formData = data
}

function onSubmit() {
  formRef.value && formRef.value.validate(async (valid) => {
    if (valid) {
      if (state.actionType === 1) {
        const { msg } = await createOcAdmin(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
      else {
        const { msg } = await updateOcAdmin(state.formData)
        ElMessage.success(msg)
        state.dialogVisible = false
        emit('success')
      }
    }
  })
}

function onCancel() {
  state.dialogVisible = false
}

function resetFormData() {
  state.formData = {
    ocId: undefined, // 企业Id
    adminId: undefined,
    adminName: '', // 账号
    adminPhone: '', // 手机号
  }
}

defineExpose({
  showAddModel(ocId: number) {
    resetFormData()
    state.title = '新增管理员'
    state.actionType = 1
    state.dialogVisible = true
  },
  showEditModel(ocId: number) {
    resetFormData()
    state.title = '编辑管理员'
    state.actionType = 2
    state.dialogVisible = true
    getData(ocId)
  },

})
</script>

<template>
  <el-drawer v-model="state.dialogVisible" :title="state.title" width="600px" :close-on-click-modal="false" append-to-body destroy-on-close>
    <el-form ref="formRef" :model="state.formData" :rules="formRules" label-width="120px" label-suffix="：">
      <el-form-item label="管理员名称" prop="adminName">
        <el-input v-model="state.formData.adminName" placeholder="请输入账号" />
      </el-form-item>

      <el-form-item label="管理员手机号" prop="adminPhone">
        <el-input v-model="state.formData.adminPhone" placeholder="请输入手机号" />
      </el-form-item>
    </el-form>

    <template #footer>
      <el-button size="large" @click="onCancel">
        取消
      </el-button>
      <el-button type="primary" size="large" @click="onSubmit">
        保存
      </el-button>
    </template>
  </el-drawer>
</template>
